<!DOCTYPE html>
<html>
<head>
	<script src="js/jquery.min.js"></script>

    <script type="text/javascript">
		// Websocket URL
		var wsUri = "ws://localhost:8000/ex-irc"; 
		
		
		var output;  
		
		$(document).ready(function() {
			// Define the output
			output = $("div#log"); 
			
			// Initialize the websocket
			initWebSocket(); 
			
			// Define action to send a message
			$('#send').click(function(){
				writeToScreen({from: 'you', msg: $('#message').val()});
				/* Code should come here */
			});
			
			// Define action to update username
			$("#update-username").click(function() {
				writeToScreen({from: 'you', msg: ' You\'re now known as ' + $('#username').val()});
				/* Code should come here */
			})
		});
		
		// Initialize the websocket
		function initWebSocket() { 
			websocket = new WebSocket(wsUri); 
			
			// What's going on when opening connection
			websocket.onopen = function (evt) { 
				console.log('Websocket open.');
				$('#status').removeClass().addClass('online').html('online');
				writeToScreen({from: 'you', msg: 'Connected to ' + wsUri});
				$('#send, #message').attr('disabled', false);
			}
			
			// What's going on when connection become closed
			websocket.onclose = function(evt) { 
				console.log('Websocket closed.');
				$('#status').removeClass().addClass('offline').html('offline');
				$('#send, #message').attr('disabled', true);
				// Try to reinit connexion in 5 sec
				setTimeout(initWebSocket, 5000);
			} 
			
			// What's going on when receiving a message
			websocket.onmessage = function(evt) { 
				console.log('Message received.');
				var data = JSON.parse(evt.data);
				
				switch(data.type) {
					/* Code should come here */
				}
				
			}  
			
			// What's going on when an error is thrown
			websocket.onerror = function(evt) { 
				console.error('Error')
				$('#status').removeClass().addClass('error').html('error');
			}
		}
		
		// Used to update the users list
		function updateUsers(data) {
			$("#users").html('');
			for(i = 0; i < data.length; i++) {
				$("#users").append('<li>'+data[i]+'</li>');
			}
		}
		
		// Used to add a message in the output
		function writeToScreen(data) { 
			var pre = document.createElement("pre"); 
			pre.style.wordWrap = "break-word"; 
			pre.innerHTML = '['+data.from+']: '+data.msg; 
			output.append(pre); 
			output.animate({scrollTop: output.attr('scrollHeight')})
		}  

	</script>
	<meta charset=utf-8 />
	<style type="text/css">
		body { background: #f1f1f1; padding-top: 65px; text-align: center; font-family: Arial, Helvetica, sans-serif; text-align: center; font-size: 16px; line-height: 25px; color: #444; }
		a, a:hover { color: #169; }
		p {  margin: 0; padding: 0 0 21px 0; }
		h1 { font-size: 30px; color: #333; font-weight: normal; margin: 0 0 20px 0; padding: 0; }
		pre { margin: 1px 0;}

		#container { text-align: left; width: 770px; background: #fff; position: relative; margin: 0 auto; padding: 40px; border: 1px solid #ddd; border-radius: 10px; -moz-border-radius: 10px; }
		#status { float: right; padding: 0 10px; border-radius: 5px; -moz-border-radius: 5px; }
		#users { width: 200px; float:left; margin: 20px 20px 0 0;  padding: 5px; border: 1px solid #ccc; height: 200px; overflow: auto;}
		#log { width: 520px; margin: 20px 0 0 0; padding: 5px; border: 1px solid #ccc; height: 200px; overflow: auto; }
		
		.offline { background: #ddd; color: #000; }
		.online { background: #093; color: #fff; }
		.error { background: #930; color: #fff; }
		.connecting { background: #fc0; color: #000; }
		.clear { clear: both;}
	</style>
	<title>IRC Client</title>
</head>
<body>

    <div id="container">
        <h1>IRC Client</h1>
		<input type="text" id="message" placeholder="message to send"/>
        <button id="send">Send</button>
        <span id="status" class="offline">offline</span>
		<div class="clear"></div>
		<input type="text" id="username" placeholder="username"/>
        <button id="update-username">Update</button>
		<div class="clear"></div>		

		<ul id="users">
		</ul>

        <div id="log">
        </div>
    </div>
</body>
</html>​