<?php

namespace WebSocket\Application;

/**
 * IRC Application
 * 
 * @author Jérome Freyre <jerome.freyre@heig-vd.ch>
 */
class IRCApplication extends Application
{
	/**
	 * Represent the client list
	 */
	private $clients = array();

	/**
	 * Is a flag that indicate if a user has been updated
	 */
	private $diffOnClients = false;

	/**
	 * Will be called when a client connect.
	 */
	public function onConnect($client) {
		$this->clients[] = $client;
	}

	/**
	 * Will be called when a client disconnect.
	 */
	public function onDisconnect($client) {
		$key = array_search($client, $this->clients);
		if ($key) {
			unset($this->clients[$key]);
		}
	}

	/**
	 * Will be called when a client send data
	 */
	public function onData($data, $client) {
		// Decode received data
		$data = json_decode($data);
		
		// Based on type
		switch($data->type) {
			/* Code should come here */
		}
	}

	/**
	 * Called when a client update his username
	 */
	public function updateUsername($username, $client) {
		/* Code should come here */
	}
	
	/**
	 * Called to broadcast a message
	 */
	public function broadcastMsg($data, $client) {
		/* Code should come here */
	}
	
	/**
	 * Is always called
	 * @note Use with caution!
	 */
	public function onTick() {
		// Will do something only if needed
		if ($this->diffOnClients) {
			/* Code should come here */
		}
	}
}